#include <bits/stdc++.h>
using namespace std;

int main() {
    int N, E;
    cin >> N >> E;
    vector<int> epizody(N);
    for (int n=0; n<N; ++n) cin >> epizody[n];

    int prva = 0;
    while (prva < N && epizody[prva] != 1) ++prva;
    int posledna = N-1;
    while (posledna >= 0 && epizody[posledna] != E) --posledna;
    if (posledna < prva) {
        cout << -1 << endl;
        return 0;
    }

    vector<int> ostalo;
    for (int i=prva+1; i<posledna; ++i) {
        if (1 < epizody[i] && epizody[i] < E) {
            ostalo.push_back( epizody[i] );
        }
    }
    
    if (ostalo.size() <= 20u) {
        int answer = 2;
        N = ostalo.size();
        for (int subset = 0; subset < (1<<N); ++subset) {
            vector<int> chosen;
            for (int n=0; n<N; ++n) if (subset & 1<<n) chosen.push_back( ostalo[n] );
            bool dobre = true;
            for (unsigned i=0; i+1<chosen.size(); ++i) dobre = dobre & (chosen[i] < chosen[i+1]);
            if (dobre) answer = max( answer, 2+int(chosen.size()) );
        }
        cout << answer << endl;
    } else {
        // give an almost-surely-incorrect answer
        cout << 3 << endl;
    }
}
